'You have hacked a sampler board, and your microcontroller.. erh - your robot's brain
'should be able to control it.

'This test is to see if this works
'Make sure to first run test 1

'The program should make 3 beeps, start recording, make one beep, play back, and start over
'if this is not the case, make sure the cables to the sampler board are hooked up as they should be

Symbol pinSC_beep = 0

begintest:
sound pinSC_beep,(117,1) low pinSC_beep pause 100
sound pinSC_beep,(117,1) low pinSC_beep pause 100
sound pinSC_beep,(117,1) low pinSC_beep pause 100
low portc 2 ' record
wait 3
high portc 2 ' Stop record
sound pinSC_beep,(120,1) low pinSC_beep pause 100
low portc 3 ' playback
wait 3
high portc 3 ' stop playback
wait 1
goto begintest

'To use the program, wait for the 3 beeps. Then sing a song (a short one), and when the robot beeps 
'one time, you will hear your wonderful soprano!
'You will never need to talk with other people again :)

'Note: If you are having problems uploading new programs after this, it is just because 
'you cannot upload programs when the microcontroller is in "pause". Just try and hit the spot when it 
'changes state, and you will be fine :)