#rem

Hi there, time to get funky :)

First: 

Make sure you have completed all the previous tests associated with this code.
Then try to upload this program to your robot.

All your robot should do after that, is make some rather irregular clicks.

Have a look at the very end of this code, look for where it says 

===
song7:
===

What you see a little below 

===
song7:
===

- is a series of "cases" - from Case 1 to Case 16. These are working as your "sequencer" (a list of 16 "notes"). For each "case", there is a line with 0's and 1's, like this:

===
case 1 '***
b0= %00001000 b1= %00000000
===

Now try to change case 1, so it says

===
case 1 '***
b0= %00001001 b1= %00000000
===

(Change the last digit in b0 from 0 to 1 - make sure there is still 8 digits there). Then upload this program to your robot again.

Now your robot should strike both BassDrum and make a clicking sound on beat 1, and then play 15 clicks, before doing it again.

So, you have seen that a "0" represents nothing, and a "1" makes the robot do something. In this case (the last digit in b0), it makes the BassDrum sound, on the first beat.

To get funky, also add a BassDrum on case 5, 9, 12, and 14 

Run the program - funky BassDrum, right? :D

But.. is the BassDrum hitting at the exact same time as the click?

It may be hard to hear if it hits at the same time, if you are not a trained drummer, and because the motors makes noise. 
If you have problems with hearing it, then one way of checking, is to record the sound made with a sound recording
software that can show waveforms, and then zoom in to see if the 2 sounds are at the same time.

Another is just to "feel" it; Do you think it has a swing - well, then no science can beat it. If it swings, it swings :)

At any rate, in this program, I will show you how to "tune" all the instruments, so they are tight on the beat.
This is of paramount importance for the robot to sound any good. Trust me, skipping this will make an awful drummer.

You may ask why I did not just "tune" it for you? Well, every robot is different. There's no way I can know how fast or slow your 
robots sticks and other instruments are. The only thing I know for sure, is the clicking sound made with the 
speaker. And that is why we are starting with that, and try to tune everything else to that beat.

You may also wonder why the clicks are so irregular. There are 2 reasons for this:
One is that they have "shuffle" which means that they are not supposed to have the exact same time between them. 
Shuffeling is what makes music swing. Another reason is that the way I programmed this, and the whole nature of the robot
means that this is not sounding like a machine; It is quite "alive". You may have heard the beats on some of my videos, 
and you may have noticed that a Yellow Drum Machine actually has a funky beat.

If you want to remove the shuffle, look for the part in the code that says

===
'TEST 1
tempo = 30 shuffle = 70
gosub song7
goto player
'TEST 1
===

and change it to (set shuffle to 0, and tempo to 50)

===
'TEST 1
tempo = 50 shuffle = 0
gosub song7
goto player
'TEST 1
===

Now it sounds more like a robot, right? :)

If it is easier for you to run the tuning that we are about to do, without shuffle, you can adjust tempo and shuffle there, while you work with it. 
Later we will remove this part of the code all together. So for now just set it as you think is easier to tune with for now.

Next, find the place in the code that says 

===
'TUNING **********************************************
===

Below this, you will see another set of 10 "cases", looking different than the sequencer.

In each of these tuning-cases, one or more instruments are switched on.

The theory behind this is, that if we told the robot to switch on all motors and other instruments at the same time,
they'd not sound at the same time. Why? Because:

When you tell the speaker to make a little "click", it does so right away. But when you switch on the motor for a drum stick,
it takes a little time from when you switch it on, till it actually hits an object and makes a sound.

So what the YDM code does, is for each of the 16 "sequencer notes" in the "song" that you worked with above (song 7), - it starts a count down:

Let us say that both a drum stick and a click should sound at the next beat, because they both have 1's in the sequencer. 
So the program works "backwards"; It says "OK, a click and a drum is coming up in some milliseconds (on the next beat).. 
So, I'd better start swinging that drumstick now, and wait for it to hit.. And just when it hits, I should also make the clicking sound."

The place this timing is programmed, is in the "TUNING" part of the program.

If you later upload another program that has the same structure, all you will have to do, is to insert the "Tuning" that you are making now.

Each instrument's "block" should be moved up or down in the "TUNING"-cases, dependent on how fast or slow it is to react.

Instruments/events placed higher, should be the ones taking longer time to sound.

Try to move (cut and paste) this block:

===
' BassDrum ******
	if BD = 1 then
	high pinBD
	end if
	if eBD = 1 and ebeat > 58 then
	high pinBD
	ebeat = ebeat + 6
	end if
' BassDrum ******
===

- up or down in the cases. You can have several instruments in the same case, but each instrument should only be represented once.

Then upload the program again. Note how moving it up or down makes the BassDrum hit before, on, or after the clicks.
It does not have to sound EXACTLY the same time as the click - but it does have to be close, and at the spot where it sounds good.
As written above; This is very, very important, for the robot to be funky in the end.

When you think the BassDrum is tuned right (you can always come back to it), add a SnareDrum to 5 and 13, in "Song 7", like this:

===
case 5 '***
b0= %00001011 b1= %00000000
===

===
case 13 '***
b0= %00001010 b1= %00000000
===

(Change the second last digit in b0 from 0 to 1 - make sure there is still 8 digits in total)

Place your robot in front of an object, and run the program.. 
Now you should have a beat of clicks, BassDrum and SnareDrum (one of the two front sticks).

Is the SnareDrum hitting too early or too late in the beat?

Try to move this part up or down in the tuning-part-cases:

===
' SnareDrum ******
	if eSD = 1 and ebeat > 78 then
	high pinSD
	ebeat = ebeat + 6
	end if
	if SD = 1 then
	high pinSD
	else
	low pinSD
	end if
' SnareDrum ******
===

Place it in the case where the robot sounds like a relaxed, but tight drummer to you :) A good rule of thumb is:
If in doubt, use "the lover cases": It is better that an instrument sounds too late than too early. But try to get it right on :)

This is how you will need to tune all the "instruments". here are some guides, but I expect you to understand the basics now, and 
just tune yourself, till you think you have a complete "Tuning-block" set up to a tight and swinging beat. Read on for a little help.

Just below

===
song7:
===

- I have written what the different bits makes the robot play:

(HeadLeft)(HeadRight)(not used)(SamplePlay)(SpeakerClick)(HiHat)(SnareDrum)(BassDrum)  (extraSnareDrum)(extraBassDrum)(not used)(BeltReverse)(BeltForward)(not used)(not used)(not used)


As this takes up so much space, in the rest of this, I have replaced it with this:

HL HR nu SP SC HH SD BD - eSD eBD nu BR BF nu nu nu

The "not used" parts are sometimes used by me, when I play with this project. For instance the robot could trig a signal to another robot, or move an extra part.
But to keep things simpler for you, I have omitted them for now. What you are making here is a quite complex machine, and if you feel like it later, you can come back and upgrade.

Here are more details on each of the "instruments" in use:

** HeadLeft and
** HeadRight: 
These makes the robot look to the Left/Right when set to 1 in the "songs". When the robot is close in front of objects, and is moving it's head, its "eyes" might touch the object. 
If so, this will also make a sound! So make sure to tune head movements as well as drums etc, so that the sounds made from touching objects with "the eyes" are also tight on the beat.
It all makes a funky drummer in the end :)

To make things easier for you, I have placed HeadLeft and HeadRight in the same block of code, it looks like this, and should be placed in the right "case" by you:
===
' Move head ******
	if HL = 1 then
	gosub headright
	end if	
	if HR = 1 then
	gosub headleft
	end if
	if HL = 0 and HR =0 then
	gosub headforward
	end if
' Move head ******
===
 
 
** SamplePlay: 
When the robot is in autonomous mode, it decides when to record sounds on the sampler board (Usually when it first meets an object to play on)
However, you can control when to play back a sample, if you decide to make your own "songs".

Here is a version of "song 7" that I made for you, and you can just copy-paste this, and overwrite the "song 7" below. 
Note that this one is special; There are 2 lines that are not normally in the "songs". It is "SRA = 1", and the first "SRA = 0".
These are in this special song, because now, for the tuning of the sampler board, we want to control when the robot is recording, and when it stops recording. 

Make a backup (or out comment the lines as described when done), and then while tuning the sampler board use this instead of your present "song 7":

===
song7:
{' b0= HL HR nu SP SC HH SD BD  b1= eSD eBD nu BR BF nu nu nu
beatcount = 0

SRA = 1 ' TEST 1 ' when done testing the sampler board, write a little ' sign in front of this line, and it will be ignored

Loop_breakbeat7:  'XXX
beatcount = beatcount +1

select case beatcount

case 1 '***
b0= %00001001 b1= %00000000

case 2
b0= %00001000 b1= %00000000

case 3
b0= %00001000 b1= %00000000

case 4
b0= %00001000 b1= %00000000

case 5 '***
b0= %00001010 b1= %00000000

case 6
b0= %00001000 b1= %00000000

case 7
b0= %00001000 b1= %00000000

case 8
b0= %00001000 b1= %00000000
SRA = 0 ' TEST 1 ' when done testing the sampler board, write a little ' sign in front of this line, and it will be ignored

case 9 '***
b0= %00011000 b1= %00000000

case 10
b0= %00001000 b1= %00000000

case 11
b0= %00001001 b1= %00000000

case 12
b0= %00001000 b1= %00000000

case 13 '***
b0= %00001010 b1= %00000000

case 14
b0= %00001001 b1= %00000000

case 15
b0= %00001000 b1= %01100000

case 16
b0= %00001000 b1= %00000000

SRA = 0

case 17
return

end select
gosub slag
goto Loop_breakbeat7 'XXX
===

If you have followed me to here, this should make the robot play a beat. In the first 8 "cases" it should record, And after another 8 start playing back.
In order to tune the sample playback, you will need to move the two blocks labeled

' Record sample ******

and

' Play back sample ****** 

- up or down in the Tuning part of the code. (Move the whole blocks, to keep this shorter, I only wrote their names)

If you start recording too late (low numbers), you might risk that the sampler board does not have time to react. So keep that high, and
find a good place for the Play back -block.

OK.. did you find it? Is the robot drumming, recording, and playing back? I put in a little extra beats for you, for it not to be too repetitive - more on that later.

Now, try to drum on the table where the robot stands. It should record that, and play it with the beat. Check that out, you are jamming with a Yellow Drum Machine :D

Make sure you have some shuffle on! (see above, if you switched it off)

I am sitting here in my workshop, it is summer, and it is hot & humid. 
I am thinking if any one will ever sit out there and jam like me to this? 
If you sit out there and jam with your YDM now, please send me a mail to this address: 
fritslyneborg+funky@gmail.com 
- let the subject line be "Funky" - It will make me happy, thanks :D

OK, let's move on, you want this thing to start driving around, right? :)

Just note that with the state the robot is in now, it is actually a fine jamming partner - you can also play a guitar etc to it :)

And also; Note how loud the sample playback is. I'll place some tape and cotton or something on my speaker, because I think it is much too loud. 
If you are into electronics, you might add a resistor or something fancy ;)
The drums should drive this beat, the samples are just as a background thing IMHO. But it is good to have them loud at first, when you test.


** SpeakerClick:  
We've already covered that: A "1" on this "instrument", makes the speaker underneath the robot do a "clicking sound".

** HiHat: 
This is the other front stick. Set it to play in "Song 7", preferably the same places as the other stick (SnareDrum, 
case 5 and 13 if you are still using my "song 7" from above), so you can hear if they hit at the same time. 
If it makes it easier, change the "SamplePlay" in the song to 0, so you only hear the drums.
When in tune, place it's block in the right case in the Tuning-part of the code. 

** SnareDrum:
Already playing - make sure it is tuned

** BassDrum: 
Already playing - make sure it is tuned

- And then there are the b1's (the remaining 0's and 1's) in the songs.
Note that you do not have to have b1's in the songs! This can come in handy if your chip runs out of memory :) BUT:
Note that if b1 is set to something in a case, it will remain that way, if nothing is coming after it. So it will repeat!

** extraSnareDrum:  
and
** extraBassDrum: 
These are played "sometimes", according to a little math. If you have a place in the rhythm, where you think that you _might_ want a stick
to be hit, let this be 1 - and it will play _sometimes_ - usually after a little while of drumming. Good for "fillers" :)


** (BeltReverse)
and
** (BeltForward)

These makes the robots belt tracks move to the beat. Together with a moving head, this is how the robot is "dancing" :) (How silly is this, when you come to think of it? :D)

These should be fairly easy to tune, as they should just look good in your opinion.

If you are making your own "songs", you should note that "BeltForward" should be in higher cases (have longer time) 
than "BeltReverse", because we want to make sure that we drive as much (and a little more) forward than reversing, 
so we are not slowly moving away from the object, but keep pushing it a bit, as we dance and play.

Playing with the belt tracks while testing recording and playback may also make you want to move the microphone.
it turned out that the place I had thought looked cool for my microphone made it pick up the belt tracks very loud!
You may want to move the microphone so it mostly picks up the sound from the sticks when they hit something.



OK - you should now be done testing and tuning. Make sure to have a good beat going on "song 7". If you have made a mess, just copy your "tuning block" (unless that is also a mess, in which case you will have to start all over), download this entire program again from the web, and paste in your "tuning block". 

Now make a good "Song 7": Add some drums to it :)

If you'd like to mess with the other "songs" that I have made for you, find this code:

===
'TEST 1
tempo = 30 shuffle = 70 ' when done testing, write a little ' sign in front of this line, and it will be ignored
gosub song7 ' when done testing, write a little ' sign in front of this line, and it will be ignored
goto player ' when done testing, write a little ' sign in front of this line, and it will be ignored
'TEST 1 
===

And change the part that says "gosub song7" to for instance "gosub song5". Note that you will not get the sample playback, 
so it will be very basic patterns. Magic happens once the robot samples from stuff it finds, and plays beats in mix :)



That's it for the tuning. Let's let it drive and drum on it's own :)

Here are the modifications you will need for this to happen:

Change this:

===
'TEST 1
goto playsomebeats ' when done testing, write a little ' sign in front of this line, and it will be ignored
'TEST 1
===

into this:

===
'TEST 1
'goto playsomebeats ' when done testing, write a little ' sign in front of this line, and it will be ignored
'TEST 1
===

Now the robot will start seeking something to play when switched on.

Change this:

===
'TEST 1
tempo = 30 shuffle = 70
gosub song7
goto player
'TEST 1
===

into this:

===
'TEST 1
'tempo = 30 shuffle = 70
'gosub song7
'goto player
'TEST 1
===

- and if you still have these lines in song7:

===
SRA = 1 ' TEST 1 ' when done testing the sampler board, write a little ' sign in front of this line, and it will be ignored
===
and this one on case 8 (do not touch the one on case 16)
===
SRA = 0 ' TEST 1 ' when done testing the sampler board, write a little ' sign in front of this line, and it will be ignored
===

-simply remove these lines, or out comment them, by adding a ' in front of them.



This will make the robot start mixing the different beats, and chose it's own speed and shuffle, when it is playing.

I hope you have fun, and if you have questions to me, I can be found on letsmakerobots.com/node/1050

I hope to see and hear your robot online :)

Frits Lyneborg - letsmakerobots.com/user/4 - Summer 2011


From the "endrem" below this line starts the real code. You can delete everything from the line below this, and to the top.
#endrem



'First we need to set up some variables, and set some ports:
{

high portc 0

high portc 2
high portc 3
high portc 4
high portc 5
high portc 6
high portc 7

pause 200 ' make sure all systems are ready


' HR HL SR SP SC HH SD BD

symbol BD = bit0 ' Bass Drum
symbol SD = bit1 ' Snarre Drum
symbol HH = bit2 ' Hi Hat
symbol SC = bit3 ' Speaker Click
symbol SP = bit4 ' Sample Play
symbol SR = bit5 ' Sample Record
symbol HL = bit6 ' Head Left
symbol HR = bit7 ' Head Right

' eSD eBD BBR BLR BL BR - -

symbol BR = bit10 ' Belt Right
symbol BL = bit11 ' Belt Left
symbol BLR = bit12 ' Belt Left Reverse
symbol BRR = bit13 ' Belt Right Reverse
symbol eBD = bit14 ' Extra Bassdrum (for small variations in the beats)
symbol eSD = bit15 ' Extra Bassdrum (for small variations in the beats)

symbol SRA = bit16 ' Sample Play Advanced! 
symbol SHFL = bit17 ' Shuffle-bit (to enable a swing in the beat)

symbol tempo = b4 ' speed of current beat
symbol countinslag = b5 ' Counting down inside each 16th note, to enable different instruments to be fired at different times ahead of sound
symbol shuffle = b6 ' Amount of Shuffle
symbol ebeat = b7 ' To enable extra beats now and then ("weak beats")
symbol beatcount = b8 ' Internal counter in a beat - normally up to 16, this decides "case"

' W6 (b12, b13) are used for variable "range"

'-----------------------------------------------------------
'Routines to select basic beat patterns
'___________________________________________________________

symbol antalsange = 7 ' (Must always be one less than total number of basic beat patterns)
symbol RandomTrackBB = b9
symbol RandomTrackMainBeat = b10
symbol RandomTrackMainbeatCstykke = b11

}


' Setting up the hardware configurations and variables
YDMIIsetup:


{
Symbol pinBD = 3
Symbol pinSD = 1
Symbol pinHH = 2
Symbol pinSC_beep = 0

goto finishsetupYDMII

efterslag: ' this is happening after each 16'th note

low 3
low 2
low 1
high portc 3 ' off playback (the sampler board will continue after it is initiated to play)
return

playback:
low portc 3 ' playback
return

offplayback:
high portc 3 ' off playback
return

''''
leftbeltreverse:
high 5 low 4 'Left Belt Reverse
return

LeftBeltForward:
high 4 low 5 'Left Belt forward
return

SnakeLeft:
high 4 low 5 'Left Belt forward
low 6 low 7 ' stop Right Belt
return

SnakeRight:
high 6 low 7 'Right Belt forward
low 4 low 5 ' stop Left Belt
return

stopleftbelt:
low 4 low 5 ' stop Left Belt
return

rightbeltreverse:
high 7 low 6 'Right Belt Reverse
return

DriveReverse:
high 7 low 6 'Right Belt Reverse
high 5 low 4 'Left Belt Reverse
return

rightbeltforward:
high 6 low 7 'Right Belt forward
return

DriveForward:
high 6 low 7 'Right Belt forward
high 4 low 5 'Left Belt forward
return

stoprightbelt:
low 6 low 7 ' stop Right Belt
return

DriveLeftTurn:
high 4 low 5 'Left Belt forward
high 7 low 6 'Right Belt Reverse
return


DriveRightTurn:
high 6 low 7 'Right Belt forward
high 5 low 4 'Left Belt Reverse
return
''''''''''''''''''''''''''''''

TotalHalt:
low 5 low 4 low 7 low 6
return

headleft:
low portc 6 high portc 7' Head Left
return

headright:	
low portc 7 high portc 6' Head Right
return

headforward:
low portc 6 low portc 7' Head Forward
return

finishsetupYDMII:
}


symbol trig = 0 ' Define output pin for Trigger pulse
symbol echo = 1 ' Define input pin for Echo pulse
symbol range = w6 ' 16 bit word variable for range


'NAVIGATION
{

symbol headdelay = 200 ' How long time should we wait before we know that the head is turned
symbol R = b25 ' Scanned distance right
symbol L = b24 ' Scanned distance left
Symbol F = b21 ' Scanned distance front
Symbol Dist = b20 ' Difference between 2 distances
symbol siksaktest = b19 ' Are we zigzagging? And is there something to hit?




'TEST 1
goto playsomebeats ' when done testing, write a little ' sign in front of this line, and it will be ignored
'TEST 1




goto Navigatorstart ''''''''''''''' Skal ikke vaere remmet, kun for video og test

'Snake - this is when the robot is seing something in front, and is trying to "snake" it's way into place
{
snakepause:
pause 300 gosub puls gosub rangeto255 pause 20
return

SnakeStart:
gosub totalhalt 
'XXXXXXXXXXXXXXXXXXXXXXX make sticks jump a tiny bit, and make a sound when stopping
high pinSD high pinHH
sound pinSC_beep,(114,1) sound pinSC_beep,(117,1) low pinSC_beep
pause 100
low pinSD low pinHH
'XXXXXXXXXXXXXXXXXXXXXXX

Snake:
gosub headleft
gosub snakepause
R = range 
gosub headright
gosub snakepause
L = range 
gosub headforward
gosub snakepause
F = range 


' Are all distances less than middle?
if R < F and L < F then ' Something on both sides - help!
gosub totalhalt sound pinSC_beep,(150,5) pause 30 sound pinSC_beep,(150,5) pause 300 sound pinSC_beep,(150,5) pause 300 sound pinSC_beep,(100,5) low pinSC_beep
gosub totalhalt
goto Navigator
end if

' Same distance to Left and Right? Well, then just drive ahead till F is.. well, see next part..
Hurra:
If R = L then
sound pinSC_beep, (120, 3) low pinSC_beep
gosub DriveForward
gosub puls gosub rangeto255
siksaktest =0
end if


'Are we close enough? Well, then stop. Prepare to beat!
if F < 3 then
sound pinSC_beep, (110, 1) low pinSC_beep
gosub totalhalt

'''''''''''''''''Time to play!!'''''''''''''''''''
gosub puls
if range > 16 then
gosub driveForward pause 500 gosub totalhalt
end if


Gosub Playsomebeats ' that should be self explaining :)
wait 1
gosub DriveReverse ' that should be self explaining :)
wait 1
goto navigatorstart ' that should be self explaining - start over, after done playing :)
end if


''''''''''''''''''''' If one distance to one side is less than middle, we'll turn. Else we'll slide!

if R < F then 
notenoughR:
gosub DriveRightTurn

gosub puls gosub rangeto255 
if R <= range and F > range then 
F = range 
goto notenoughR
end if
gosub totalhalt
end if

if L < F then 
notenoughL:
gosub DriveLeftTurn
gosub puls gosub rangeto255 
if L <= range and F > range then 
F = range
goto notenoughL
end if
gosub totalhalt
end if


if R > L then

dist = R-L
if dist < 1 then
R=L
goto hurra
end if

if dist < 50 then 
dist = 50
end if

'**********
'OK, we are trying to place ourselves in front of an object. But if all we do is keep zig-zagging, then never mind, let's just drive right ahead instead :)
if siksaktest = 0 then
siksaktest = 1
goto slutsiksaktest1
end if
if siksaktest = 1 then
siksaktest = 0
end if
'
if siksaktest = 2 then
siksaktest = 3
goto slutsiksaktest1
end if
if siksaktest = 3 then
siksaktest = 0
end if
'
if siksaktest = 4 then
L=R
sound pinSC_beep, (130,3) pause 30 sound pinSC_beep, (130,3) pause 30 sound pinSC_beep, (130,3) pause 30 low pinSC_beep
goto hurra
end if
'
'''***
if siksaktest = 10 then
siksaktest = 20
goto slutsiksaktest1
end if
if siksaktest = 20 then
siksaktest = 0
end if
'
if siksaktest = 30 then
siksaktest = 40
goto slutsiksaktest1
end if
if siksaktest = 40 then
siksaktest = 0
end if

'***********
slutsiksaktest1:


gosub leftbeltforward
gosub rightbeltreverse
pause dist
gosub stoprightbelt
pause dist pause dist pause dist
gosub totalhalt

end if

if L > R then

dist = L-R
if dist < 1 then
L=R
goto hurra
end if

if dist < 50 then 
dist = 50
end if
'**********
'OK, we are trying to place ourselves in front of an object. But if all we do is keep zig-zagging, then never mind, let's just drive right ahead instead :)
if siksaktest = 1 then
siksaktest = 2
goto slutsiksaktest2
end if
if siksaktest = 2 then
siksaktest = 0
end if
'
if siksaktest = 3 then
siksaktest = 4
goto slutsiksaktest2
end if
if siksaktest = 4 then
siksaktest = 0
end if

'''***
if siksaktest = 0 then
siksaktest = 10
goto slutsiksaktest2
end if
if siksaktest = 10 then
siksaktest = 0
end if

if siksaktest = 20 then
siksaktest = 30
goto slutsiksaktest2
end if
if siksaktest = 30 then
siksaktest = 0
end if

if siksaktest = 40 then
L=R
sound pinSC_beep, (30,3) pause 30 sound pinSC_beep, (30,3) pause 30 sound pinSC_beep, (30,3) pause 30 low pinSC_beep
goto hurra
end if


slutsiksaktest2:


gosub rightbeltforward
gosub leftbeltreverse
pause dist
gosub stopleftbelt
pause dist pause dist pause dist
gosub totalhalt

end if

goto Snake

}

' Navigator - the part of the program that drives the robot around
{
Navigatorstart:
gosub totalhalt 
Navigator:

dist = dist + 1' For deciding when we should stop driving around, and start thinking about drumming
	select case dist
	case 12
					'XXXXXXXXXXXXXXXXXXX
					shuffle = b12' first bit of the word variable for range
					shuffle = shuffle / 4
					tempo = 65 - shuffle
					tempo = tempo / 4  max 20 min 3
					'XXXXXXXXXXXXXXXXXXX
	
	case 20, 212

					'XXXXXXXXXXXXXXXXXXX
					inc RandomTrackMainbeatCstykke
					if RandomTrackMainbeatCstykke > antalsange then
					RandomTrackMainbeatCstykke = 0
					end if
					'XXXXXXXXXXXXXXXXXXX
	
	
	case 40, 168, 232
					'XXXXXXXXXXXXXXXXXXX
					inc RandomTrackBB 
					if RandomTrackBB > antalsange then
					RandomTrackBB = 0
					end if
					'XXXXXXXXXXXXXXXXXXX
									
	case 234 ' se lige til hoejre eller venstre en gang imellem
	goto LRcheck
	case 191,  221, 72, 4
					'XXXXXXXXXXXXXXXXXXX
					inc RandomTrackMainBeat
					if RandomTrackMainBeat > antalsange then
					RandomTrackMainBeat = 0
					end if
					'XXXXXXXXXXXXXXXXXXX
	end select

gosub puls
if range > 155 then
gosub Driveforward
else '''''''''''''''Something is in front

''''''''''
if dist > 100 then' Set this number lower, if you want the robot to play more, and drive less. Set it to max 255, if you want it to drive a lot before deciding to drum
siksaktest = 0 dist = 0 ' cleaning up some borrowed variable
goto SnakeStart
end if

''''''''''


	gosub totalhalt
LRcheck:	'
	gosub headleft ''''''''
	pause headdelay
	gosub puls
					
	if range > 255 then 
	range = 255
	end if
	R = range
	'
	gosub headright ''''''''
	pause headdelay
	gosub puls
					
	if range > 255 then 
			range = 255
	end if
	L = range
	'
	gosub headforward' 
	pause headdelay
	
	If R > L then
		TurnRightTilSpaceInFrontOfUs:
		gosub DriveRightTurn
		gosub puls
		if range < 300 then 
'XXXXXXXXXXXXXXXXXXXXXXX
Gosub playback
'XXXXXXXXXXXXXXXXXXXXXXX

			goto TurnRightTilSpaceInFrontOfUs
					
		end if
	else

		TurnLeftTilSpaceInFrontOfUs:
		gosub DriveLeftTurn
		gosub puls
		if range < 300 then 
		
'XXXXXXXXXXXXXXXXXXXXXXX
Gosub playback
'XXXXXXXXXXXXXXXXXXXXXXX
			goto TurnLeftTilSpaceInFrontOfUs
		end if
	end if

end if

goto navigator

}



{
puls:
high portc trig
pause 10
low  portc trig
pulsin echo,1,range ' measures the range in 10uS steps
pause 10 
return

rangeto255:
if range > 255 then
range = 255
end if
range = range / 10
return
}




Playsomebeats:

{
Gosub offplayback
pause 50
Goto player

aaaa:
select case RandomTrackBB
case 0
gosub song0
case 1
gosub song1
case 2
gosub song2
case 3
gosub song3
case 4
gosub song4
case 5
gosub song5
case 6
gosub song6
case 7
gosub song7
end select
return

cccc:
select case RandomTrackMainBeat
case 0
gosub song0
case 1
gosub song1
case 2
gosub song2
case 3
gosub song3
case 4
gosub song4
case 5
gosub song5
case 6
gosub song6
case 7
gosub song7
end select
return

dddd:
select case RandomTrackMainbeatCstykke
case 0
gosub song0
case 1
gosub song1
case 2
gosub song2
case 3
gosub song3
case 4
gosub song4
case 5
gosub song5
case 6
gosub song6
case 7
gosub song7
	
end select
return

Player:

'TEST 1
tempo = 30 shuffle = 70 ' when done testing, write a little ' sign in front of this line, and it will be ignored
gosub song7 ' when done testing, write a little ' sign in front of this line, and it will be ignored
goto player ' when done testing, write a little ' sign in front of this line, and it will be ignored
'TEST 1 

SRA=1
gosub aaaa
gosub player0
gosub cccc
gosub cccc
gosub dddd
gosub cccc
gosub dddd
gosub cccc

gosub headforward
return


}

slag:
{
pause tempo
ebeat = ebeat +1
SHFL = SHFL +1
if SHFL = 0 then
pause shuffle
end if

countinslag = 11' This is minimum the time it takes for the slowest stick to hit from when it is initiated
closerstill: ' From this point all the pause routines are repeated till all sticks have hit
countinslag = countinslag - 1

select case countinslag


'TUNING **********************************************


case 10 '**********************************************
		
' tracks forward ******	
	if BL = 1 then
	gosub Driveforward
	end if
	if BLR = 0 and BL =0 then
	gosub totalhalt
	end if
' tracks forward ******

' Record sample ******
	if SRA = 1 then 
	low portc 2 ' record
	else 
	high portc 2 ' Stop record
	end if
' Record sample ******	

case 9 '**********************************************


case 8 '**********************************************


case 7 '**********************************************
		

case 6 '**********************************************	

' tracks reverse ******
	if BLR = 1 then
	gosub DriveReverse
	end if
' tracks reverse ******	

' Play back sample ******	
	if SP = 1 and SRA = 0 then
	gosub playback
	else
	gosub offplayback
	end if
' Play back sample ******

' BassDrum ******
	if BD = 1 then
	high pinBD
	end if
	if eBD = 1 and ebeat > 58 then
	high pinBD
	ebeat = ebeat + 6
	end if
' BassDrum ******

' SnareDrum ******

	if SD = 1 then
	high pinSD
	else
	low pinSD
	end if
	if eSD = 1 and ebeat > 78 then
	high pinSD
	ebeat = ebeat + 6
	end if
' SnareDrum ******

' HiHat ******
	if HH = 1 then
	high pinHH
	else
	low pinHH
	end if
' HiHat ******

case 5 '**********************************************
			

case 4 '**********************************************

' Move head ******
	if HL = 1 then
	gosub headright
	end if	
	if HR = 1 then
	gosub headleft
	end if
	if HL = 0 and HR =0 then
	gosub headforward
	end if
' Move head ******


case 3 '**********************************************


case 2 '**********************************************

	
case 1 '**********************************************

' Speaker Click ******
	if SC = 1 then
	high pinSC_beep low pinSC_beep high pinSC_beep low pinSC_beep
	end if
' Speaker Click ******
	
'END TUNING **********************************************



case 0 '**********************************************
goto slutslag
end select
goto closerstill
slutslag:

gosub efterslag
return
}



'Players
player0:
{' b0= HL HR nu SP SC HH SD BD  b1= eSD eBD nu BR BF nu nu nu
beatcount = 0
Loop_player0:  'XXX
beatcount = beatcount +1

select case beatcount

case 1 '***
b0= %00011000 b1= %01000000

case 2
b0= %00000000 b1= %00000000

case 3
b0= %00000000 

case 4

case 5 '***
b0= %00001000 b1= %11000000

case 6
b0= %00001000 b1= %00000000

case 7
b0= %00000000 

case 8

case 9 '***
b0= %00001000 b1= %01000000

case 10
b0= %00000000 b1= %00000000

case 11

case 12

case 13 '***
b0= %00001000 b1= %11000000

case 14
b0= %00000000 b1= %01000000

case 15
b1= %11000000

case 16
b1= %01000000

SRA = 0

case 17
return

end select
gosub slag
goto Loop_player0 'XXX
}


'Mainbeats
song0:
{' b0= HL HR nu SP SC HH SD BD  b1= eSD eBD nu BR BF nu nu nu
beatcount = 0
Loop_song0:  'XXX
beatcount = beatcount +1

select case beatcount

case 1 '***
b0= %00010001 b1= %00000000

case 2
b0= %00000000 

case 3
b0= %00001010 

case 4
b0= %00000000 

case 5 '***
b0= %10000101 b1= %00110000

case 6
b0= %01000000 b1= %00000000

case 7
b0= %10001000 

case 8
b0= %01000010 b1= %00001100
'SRA = 0
case 9 '***
b0= %00000001 

case 10
b0= %00000000 b1= %00000000

case 11
b0= %00001000 

case 12
b0= %00000000 

case 13 '***
b0= %00000101 

case 14
b0= %00000010 b1= %11000000

case 15
b0= %00001000 b1= %00000000

case 16
b0= %00000010 

SRA = 0

case 17
return

end select
gosub slag
goto Loop_song0 'XXX

}

song1:

{' b0= HL HR nu SP SC HH SD BD  b1= eSD eBD nu BR BF nu nu nu

beatcount = 0
Loop_song1:  'XXX
beatcount = beatcount +1

select case beatcount

case 1 '***
b0= %10011001 b1= %00000000

case 2
b0= %10001000 

case 3
b0= %10001000 

case 4
b0= %10001011 

case 5 '***
b0= %01001000 

case 6
b0= %01001000 

case 7
b0= %01001100 b1= %01000001

case 8
b0= %01001000 b1= %00000000

case 9 '***
b0= %10001000 

case 10
b0= %10000000 

case 11
b0= %10001000 

case 12
b0= %10000010 b1= %10000000

case 13 '***
b0= %01001000 b1= %00000000

case 14
b0= %01001000 

case 15
b0= %01001100 

case 16
b0= %01001000 

SRA = 0

case 17
return

end select
gosub slag
goto Loop_song1 'XXX

}

song2:

{' b0= HL HR nu SP SC HH SD BD  b1= eSD eBD nu BR BF nu nu nu

beatcount = 0
Loop_song2:  'XXX
beatcount = beatcount +1

select case beatcount

case 1 '***
b0= %00011101 b1= %00000000

case 2
b0= %10001000 b1= %00100000

case 3
b0= %10000000 b1= %00000000

case 4
b0= %10000011 

case 5 '***
b0= %01001000 b1= %00010000

case 6
b0= %01001100 b1= %00000000

case 7
b0= %01000010 b1= %00000000

case 8
b0= %01000000

case 9 '***
b0= %10001000 b1= %00001100

case 10
b0= %10000000 b1= %00000100

case 11
b0= %10001000 b1= %00000000

case 12
b0= %10001000 

case 13 '***
b0= %00000000 b1= %10000000

case 14
b0= %00000100 b1= %10000000

case 15
b0= %00001000 b1= %10000000

case 16
b0= %00000100 b1= %10000000

SRA = 0

case 17
return

end select
gosub slag
goto Loop_song2 'XXX

}

song3:

{' b0= HL HR nu SP SC HH SD BD  b1= eSD eBD nu BR BF nu nu nu

beatcount = 0
Loop_song3:  'XXX
beatcount = beatcount +1

select case beatcount

case 1 '***
b0= %00011001 b1= %00000000

case 2
b0= %00000000

case 3
b0= %01001000 b1= %01000000

case 4
b0= %00001000 b1= %00000000

case 5 '***
b0= %00001110 b1= %00000000

case 6
b0= %00000000 b1= %01000000

case 7
b0= %00001000 

case 8
b0= %00000001 b1= %00000000

case 9 '***
b0= %00001001 

case 10
b0= %00001000 

case 11
b0= %00001001 

case 12
b0= %10000000 

case 13 '***
b0= %00001110 b1= %10000000

case 14
b0= %00000000 b1= %00000000

case 15
b0= %00000000 b1= %10000000

case 16
b0= %00000000 b1= %00000000

SRA = 0

case 17
return

end select
gosub slag
goto Loop_song3 'XXX

}

song4:

{' b0= HL HR nu SP SC HH SD BD  b1= eSD eBD nu BR BF nu nu nu

beatcount = 0
Loop_breakbeat0:  'XXX
beatcount = beatcount +1

select case beatcount

case 1 '***
b0= %00010100 b1= %00000000

case 2
b0= %00000000 

case 3
b0= %00010100 b1= %10000000

case 4
b0= %00000000 b1= %00000000

case 5 '***
b0= %00001100 b1= %10000000

case 6
b0= %00000000 

case 7
b0= %00000100 b1= %10000000

case 8
b0= %00000101 b1= %00000000

case 9 '***
b0= %00001000 

case 10
b0= %00000000 

case 11

case 12
b0= %00000000 

case 13 '***
b0= %00001000 

case 14
b0= %00000000 

case 15
b0= %00000000 

case 16
SRA = 0

case 17
return

end select
gosub slag
goto Loop_breakbeat0 'XXX

}

song5:

{' b0= HL HR nu SP SC HH SD BD  b1= eSD eBD nu BR BF nu nu nu
beatcount = 0
Loop_breakbeat1:  'XXX
beatcount = beatcount +1

select case beatcount

case 1 '***
b0= %00001001 b1= %00010000

case 2
b0= %00000000 b1= %00000000

case 3
b0= %00000000 b1= %00001100

case 4
b0= %00000001 b1= %00000000

case 5 '***
b0= %00001110 

case 6
b0= %00000000 

case 7
b0= %00000000 

case 8
b0= %00001000 b1= %01000000

case 9 '***
b0= %00000001 b1= %00000000

case 10
b0= %00001000 b1= %10000000

case 11
b0= %00000100 

case 12
b0= %00001000 

case 13 '***
b0= %00001110 b1= %00000000

case 14
b0= %00001000 b1= %10000000

case 15
b0= %00001100 b1= %11000000

case 16
b0= %00000000 b1= %10000000
SRA = 0

case 17
return

end select
gosub slag
goto Loop_breakbeat1 'XXX

}

song6:

{' b0= HL HR nu SP SC HH SD BD  b1= eSD eBD nu BR BF nu nu nu
beatcount = 0
Loop_breakbeat6:  'XXX
beatcount = beatcount +1

select case beatcount

case 1 '***
b0= %10001001 b1= %00000000

case 2
b0= %10001000 

case 3
b0= %10001001 

case 4
b0= %10001000 

case 5 '***
b0= %01000110 

case 6
b0= %01001000 

case 7
b0= %01001000 

case 8
b0= %01001000 

case 9 '***
b0= %10001001 

case 10
b0= %10000000 

case 11
b0= %10001001 b1= %10000000

case 12
b0= %10001000 b1= %00000000

case 13 '***
b0= %01001110 b1= %01000000

case 14
b0= %01001000 b1= %00000000

case 15
b0= %01000000 

case 16
b0= %01001000 b1= %01000000
SRA = 0

case 17
return

end select
gosub slag
goto Loop_breakbeat6 'XXX

}



song7:
{' b0= HL HR nu SP SC HH SD BD  b1= eSD eBD nu BR BF nu nu nu
beatcount = 0
Loop_breakbeat7:  'XXX
beatcount = beatcount +1

select case beatcount

case 1 '***
b0= %00001000 b1= %00000000

case 2
b0= %00001000 b1= %00000000

case 3
b0= %00001000 b1= %00000000

case 4
b0= %00001000 b1= %00000000

case 5 '***
b0= %00001000 b1= %00000000

case 6
b0= %00001000 b1= %00000000

case 7
b0= %00001000 b1= %00000000

case 8
b0= %00001000 b1= %00000000

case 9 '***
b0= %00001000 b1= %00000000

case 10
b0= %00001000 b1= %00000000

case 11
b0= %00001000 b1= %00000000

case 12
b0= %00001000 b1= %00000000

case 13 '***
b0= %00001000 b1= %00000000

case 14
b0= %00001000 b1= %00000000

case 15
b0= %00001000 b1= %00000000

case 16
b0= %00001000 b1= %00000000

SRA = 0

case 17
return

end select
gosub slag
goto Loop_breakbeat7 'XXX

}